<!-------------------------------------------------------------------------------
 * Copyright (c) 2020 Contributors to the Eclipse Foundation
 *
 * See the NOTICE file(s) distributed with this work for additional
 * information regarding copyright ownership.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0
 *
 * SPDX-License-Identifier: EPL-2.0
 -------------------------------------------------------------------------------->

<div #textBlock (mousedown)="(editText || appDisabled || editReplacement) ? $event.stopPropagation() : null"
     [class.disabled]="appDisabled"
     [class.text-block---selected]="appSelected"
     [class.text-block---error]="appErrors?.length > 0" class="text-block openk-drag-element">

  <div class="title-bar">
    <span class="title-bar--title">
      <ng-container *ngIf="!appWithoutTitlePrefix">
        {{'textBlocks.textBlock' | translate}}
      </ng-container>
      {{appTitle | translate}}
    </span>

    <ng-template #buttonsForAdminTemplateRef>

      <div class="title-bar--buttons title-bar--buttons---admin">

        <button (click)="appDelete.emit()"
                [disabled]="appDisabled"
                class="openk-button openk-button-icon title-bar--buttons-btn">
          <mat-icon>delete_forever</mat-icon>
        </button>

        <div style="flex: 1;"></div>

        <button (click)="appUp.emit()"
                [disabled]="appDisabled || appUpDisabled"
                class="openk-button openk-button-icon title-bar--buttons-btn title-bar--buttons-btn---rotate-up">
          <mat-icon>play_arrow</mat-icon>
        </button>

        <button (click)="appDown.emit()"
                [disabled]="appDisabled || appDownDisabled"
                class="openk-button openk-button-icon title-bar--buttons-btn title-bar--buttons-btn---rotate-down">
          <mat-icon>play_arrow</mat-icon>
        </button>

        <button (click)="appEdit.emit()"
                [disabled]="appDisabled"
                class="openk-button openk-button-icon title-bar--buttons-btn">
          <mat-icon>edit</mat-icon>
        </button>

        <button (click)="appAdd.emit()" [disabled]="appDisabled"
                class="openk-button openk-button-icon title-bar--buttons-btn">
          <mat-icon>add</mat-icon>
        </button>

      </div>

    </ng-template>

    <ng-container *ngIf="!appForAdmin; else buttonsForAdminTemplateRef">
      <div class="title-bar--buttons">
        <button (click)="convertToTextInput()" *ngIf="(appType === 'block' || appType === 'text')"
                [disabled]="appDisabled" class="openk-button openk-button-icon title-bar--buttons-btn">
          <mat-icon>edit</mat-icon>
        </button>
        <button (click)="revert()"
                *ngIf="(appType === 'block' && appBlockText != null) || (appType === 'text' && appBlockText)"
                [disabled]="appDisabled"
                class="openk-button openk-button-icon title-bar--buttons-btn title-bar--buttons-btn---revert"
                name="revertButton">
          <mat-icon>backspace</mat-icon>
        </button>
        <button (click)="appNewLine.emit()" *ngIf="appShowNewLine && appTextBlockData?.length === 0"
                [disabled]="appDisabled" class="openk-button openk-button-icon">
          <mat-icon>keyboard_return</mat-icon>
        </button>
      </div>

      <div class="title-bar--error-msg">
        <span *ngIf="appErrors?.length > 0"
              class="title-bar--block-error">
          {{(appErrors[0]?.message | translate) + appErrors[0]?.ids.toString()}}
        </span>
      </div>

      <div>
        <button (click)="appDelete.emit()" *ngIf="appShowClose"
                [disabled]="appDisabled" class="openk-button openk-button-icon">
          <mat-icon>clear</mat-icon>
        </button>

        <button (click)="appAdd.emit()" *ngIf="!appShowClose"
                [disabled]="appDisabled" class="openk-button openk-button-icon">
          <mat-icon>add</mat-icon>
        </button>
      </div>
    </ng-container>

  </div>

  <div *ngIf="!editText" [class.fade]="appShortMode" class="text-block--text">

    <ng-container *ngFor="let block of appTextBlockData, trackBy: trackByIndex">

      <span *ngIf="block?.type === 'text'">{{block?.value}}</span>

      <span *ngIf="block?.type === 'highlight-text'" class="highlight-text">
        {{block?.value}}
        <mat-icon *ngIf="block?.iconType === 'input'" class="editable-text--icon">edit</mat-icon>
        <mat-icon *ngIf="block?.iconType === 'select'" class="editable-text--icon editable-text--icon---rotate">play_arrow</mat-icon>
        <mat-icon *ngIf="block?.iconType === 'date'" class="editable-text--icon">today</mat-icon>
      </span>

      <ng-container *ngIf="block?.type === 'newline'"><br></ng-container>

      <app-text-replacement (appValueChange)="valueChange(block?.value, $event, block?.type)"
                            *ngIf="block?.type === 'input' || block?.type === 'date' || block?.type === 'select'"
                            [appPlaceholder]="block?.value"
                            [appOptions]="block?.options"
                            [appType]="block?.type"
                            [appDisabled]="appDisabled"
                            (appEdit)="editReplacement = $event"
                            [appValue]="block?.placeholder">
      </app-text-replacement>

      <ng-container *ngIf="block?.type === 'text-fill'">

        <span *ngIf="block?.placeholder" class="highlight-text"><!--
          -->{{block.placeholder}}<!--
        --></span>

        <span *ngIf="!block?.placeholder" class="highlight-text error"><!--
        -->{{ block.value }}
          <mat-icon *ngIf="!block?.placeholder" class="error--icon">warning</mat-icon><!--
        --></span>
      </ng-container>

    </ng-container>

  </div>

  <div [class.hidden]="!editText">
    <textarea #inputElement
              appAutoTextFieldResize
              class="openk-textarea text-input"
              [appAutoResizeData]="editText"
              [disabled]="appDisabled"
              [value]="appBlockText"
              (focusout)="onFocusOut($event)"
              (input)="onInput(inputElement.value)">
    </textarea>
  </div>

  <button (click)="appNewLine.emit()" *ngIf="appShowNewLine && appTextBlockData?.length > 0"
          [disabled]="appDisabled" class="openk-button openk-button-icon">
    <mat-icon>keyboard_return</mat-icon>
  </button>

</div>
